// These are just some simple examples of how easy it is to program a real
// robot using the RobotBASIC-RROS combination
main: 
  gosub InitAll
  while true
    gosub CheckForVoiceCommand
    // note: the comments for the following offer commands you can SAY
    if InString(VoiceIn, "PROGRAM") then break  // end program     
    if InString(VoiceIn, "LEARN")      //Learn colors, Learn objectsi    
      gosub LearnColors
    elseif Instring(VoiceIn,"ARLO")   //ARLO
      call Say("Yes john     what can I do for you", happy)
    elseif Instring(VoiceIn, "GOOD")
      call Say("I am glad you liked it", happy)
    elseif InString(VoiceIn, "DEMO")   //Demo your emotions, do a face demo
      gosub DemoFace
    elseif Instring(VoiceIn, "NORTH")  //turn north, face north
      gosub TurnNorth
    elseif Instring(VoiceIn, "SOUTH")  //turn south, face south
      gosub TurnSouth
    elseif Instring(VoiceIn, "EAST")   //turn east, face east
      gosub TurnEast
    elseif Instring(VoiceIn, "WEST")   //turn west, face west
      gosub TurnWest
    elseif Instring(VoiceIn, "FORWARD")//move forward, forward please 
      gosub MoveForward
    elseif Instring(VoiceIn, "BACK")   //move back, move backward, backup
      gosub MoveBackward
    elseif Instring(VoiceIn, "LEFT")   //turn to your left, turn left
      gosub TurnLeft    
    elseif Instring(VoiceIn, "RIGHT")  //turn to your right, turn right
      gosub TurnRight
    elseif Instring(VoiceIn, "COME")   //come here, come to me
      gosub ComeToMe
    elseif Instring(VoiceIn, "MUCH")   //not so much, still too much
      gosub DoLess
    elseif Instring(VoiceIn, "MORE")   //a little more, do more
      gosub DoMore
    elseif Instring(VoiceIn, "LOOK")   //look at this, look here
      gosub WatchObject
    elseif Instring(VoiceIn, "PICKUP") // pickup the bottle, pickup the object
      gosub PickupObject
    elseif Instring(VoiceIn,"SCAN")  
      gosub DoScan                                // show me a scan, scan ahead   
    elseif Instring(VoiceIn, "WHICH") or Instring(VoiceIn,"IDENTIFY") 
      gosub IdentifyObject             //identify this, which bottle is this
    elseif Instring(VoiceIn, "AGAIN") or Instring(VoiceIn,"REPEAT") 
      gosub DoAgain                    //do that again, repeat please
    elseif Instring(VoiceIn, "KITCHEN")//go to the kitchen, move to kitchen 
      Dest=Kitchen                     
      gosub "From"+ToString(Cur)+"to"+ToString(Dest)
      // implement YOUR subroutines as discussed in PART 3 of this series
    elseif Instring(VoiceIn, "POOL TABLE") // go to pool table, move to pool table
      Dest=PoolTable
      gosub "From"+ToString(Cur)+"to"+ToString(Dest
      // implement YOUR subroutines as discussed in PART 3 of this series
    elseif Instring(VoiceIn, "GUARD")  //guard the house, guard while I am gone
      gosub GuardTheHouse
    elseif Instring(VoiceIn, "WHO")    //who are you
      gosub Greeting
    elseif Instring(VoiceIn,"WAYNE") or Instring(VoiceIn,"WAVE")  
      // note: sometimes windows thinks you said WAYNE when you say WAVE
      //       so check for both  
      gosub DoWave                     //wave to me, please wave
    elseif Instring(VoiceIn,"TAKE")
      gosub TakeThis
    elseif Instring(VoiceIn, "THANK YOU")
      call Say("You are welcome",happy)
    endif 
  wend
  call Say("Program will end now.    Goodbye", normal)
end

InitAll:
  scrsetmetrics ,,,,0,1
  call InitSensors(0,0,0,0)
  gosub InitAnimateSay
  gosub InitVoiceRec
  gosub InitCameras
  gosub InitArmData
  #include "RROScommands.bas"  // open this file as a normal program to see contents
  gosub InitRROScommands       // found inside the above file
  rCommPort 8  // use YOUR Bluetooth Port number
  rLocate ARLO,590
  rCommand(SetCompassType, HMC6352) // or use compass HMC5883
  data YforScan; 150,170,190,200,190,170,150
return

InitArmData:
  Data OrigPos; 1337,1332,1350,1257,1350,1425,1400,1330,1400,1375,1375,1075,1630,1780
  Data P;  1337,1332,1350,1257,1350,1425,1400,1330,1400,1375,1375,1075,1630,1780
  Data P;  0,0,0,0,0,0,0,0,0,0,0
  Dim ArmData[7,6]
  // copy data statement data into ArmData[] Array
  Data T;1474,1966,1734,1368, 925, 608
  for i=0 to 5
    ArmData[0,i]=T[i]
  next
  Dim T[0]
  Data T; 784,2208,1740,1904, 716, 749
  for i=0 to 5
    ArmData[1,i]=T[i]  
  next
  Dim T[0]
  Data T;1055,2029,1730,1700, 745, 864
  for i=0 to 5
    ArmData[2,i]=T[i] 
  next
  Dim T[0]
  Data T;1285,1940,1647,1453, 846, 912
  for i=0 to 5
    ArmData[3,i]=T[i]
  next
  Dim T[0]
  Data T;1807,1723,1629,1169,1094, 939
  for i=0 to 5
    ArmData[4,i]=T[i]
  next
  Dim T[0]
  Data T;2000,1376,1618, 939,1294, 972
  for i=0 to 5
    ArmData[5,i]=T[i] 
  next
  Dim T[0]
  Data T;2000,2080,1629, 800, 774, 939
  for i=0 to 5
    ArmData[6,i]=T[i]
  next
  Dim T[0]
  Data LeftArmPositions; 1872,1829,1812,1750,1718,1658,1594
  Data RightArmPositions; 804, 845, 913, 945,1006,1043,1100  
  LeftHandOpen = 1424
  LeftHandHalf = 1846
  LeftHandClosed = 2170
  RightHandOpen = 1000
  RightHandHalf = 1495
  RightHandClosed = 1725
  WristForWave = 1160 //+440 for other position
  LeftArmSafe = 1200
  RightArmSafe = 1525
  LeftLeftFinger=4
  LeftRightFinger=1
  LeftGrasp=16
  LeftDetectObject=8
  RightLeftFinger=64
  RightRightFinger=2
  RightGrasp=32
  RightDetectObject=128
  LtRot      =0
  LtShoulder =1
  LtElbow    =2
  LtWrist    =3
  LtWristLR  =4
  LtHand     =5
  RtRot      =6
  RtShoulder =7
  RtElbow    =8
  RtWrist    =9
  RtWristLR  =10
  RtHand     =11
  TurretHorz =12
  TurretVert =13
  GripperData =14
  USrangeData =15
  IRrangeData =16
  RangeLimit  =17
  RequestScan =18
  RequestClose=19 
return

InitCameras:
  Dim CntInfo[9,9]
  BMP="BMP"
  JPG="JPG"
return

InitVoiceRec:
  VoiceRec = "EditBox"
  AddEdit VoiceRec, 0,585,799
  AddEdit "Output", 0,550,799
  FocusEdit VoiceRec  
  LastMove=""
return

CheckForVoiceCommand:
  VoiceIn = ""
  if EditChanged(VoiceRec)
     VoiceIn = Upper(GetEdit(VoiceRec))
     SetEdit VoiceRec,""
     if VoiceIn<>"" then SetEdit "Output",VoiceIn
  endif
return

TakeThis:
  // ensure right hand is open
  P[11] = RightHandOpen
  gosub MoveServos
  // raise arm  
  P[RtShoulder]=832
  P[RtElbow]=940
  P[RtWrist]=1006
  gosub MoveServos
  call Say("Give it to me",normal)
  // wait for cross beam in hand to trigger
  repeat
    gosub MoveServos
    if P[GripperData]&RightRightFinger
      P[RtWristLR]=1132
    elseif P[GripperData]&RightLeftFinger
      P[RtWristLR]=1568
    endif
  until P[GripperData]&RightDetectObject
  // request right hand to close
  P[RtHand]=1281  // partically close hand for speed
  gosub MoveServos
  P[19]=2  // then close it till sensor is triggered
  gosub MoveServos
  call Say("I got it",happy)
  gosub DropArm
return

MoveForward:
  rForward 30
  LastMove = "Forward"
return

MoveBackward:
  rForward -30
  LastMove = "Backward"
return

TurnNorth:
  rCommand(TurnToHalfAngle,0)
  // note: this rcommand only works on the real robot (not the simulator)
  // simulator could use something like the following:
  // while rCompass()!=0
  //   rTurn 1
  // wend   
  // but the above would not be accurate for the real robot unless it moved very slowly
return

TurnSouth:
  rCommand(TurnToHalfAngle,180/2)
return

TurnEast:
  rCommand(TurnToHalfAngle,90/2)
return

TurnWest:
  rCommand(TurnToHalfAngle,270/2)
return

DoScan:
  call Say("Scanning out about two feet",normal)
  P[17]=24
  P[18]=2 // US only
  gosub MoveServos
  flip off
  clearscr
  linewidth 5
  Circle 350,10,450,110
  line 400,60,400,110
  Call Say("Here is where I see objects",noface)
  mask=1
  for ti=0 to 6
    if P[17]&mask
      Call MyCircle(ti*30+300,YforScan[ti])
    endif
    mask = mask*2
  next
  Call Say("Just say FINISHED when you are ready to continue",noface)
  repeat
    gosub CheckForVoiceCommand
  until Instring(VoiceIn, "FINISH")
  flip on
  delay 1000
  call Say("My many sensors makes me cool", happy)
return

sub MyCircle(x,y)
  r=20
  circle x-r,y-r,x+r,y+r,black,black
return

GuardTheHouse:      // create your custom routine
return

Greeting:
  call Say("My name is Arlo",normal)
  call Say("I am the robot you have always wanted",happy)
  LastMove = "Who"
return
                                                 
PickupObject: // this routine and many others will be in the book
return

DoWave:
  // position arm for wave
  P[6] = RightArmSafe
  gosub MoveServos
  for ti=3 to 5
    P[ti+4]=ArmData[6,ti]
  next
  // close hand
  P[11] = RightHandClosed
  gosub MoveServos
  // wave 
  for ti= 1 to 3
    P[10] = WristForWave
    gosub MoveServos
    P[10]+=440
    gosub MoveServos
  next
  gosub DropArm
  call Say("How was that",normal)
return

DropArm:
  P[0]=OrigPos[0]
  P[6]=OrigPos[6]
  gosub MoveServos
  for ti=1 to 4
    P[ti]=OrigPos[ti]
  next
  for ti=7 to 10
    P[ti]=OrigPos[ti]
  next
  gosub MoveServos
return

MoveServos:
  mWrite P,"DataReady"
  FileRename("DataReady","ProcessNow")
  repeat
  until FileExists ("DataReady")
  delay 10
  mRead P,"DataReady"  
return

TurnLeft:
  rTurn -40
  LastMove = "Left"
return

TurnRight:
  rTurn 40
  LastMove = "Right"
return

DoMore:
  if LastMove = "Right"
     rTurn 10
  elseif LastMove = "Left"
     rTurn -10
  elseif LastMove = "Forward"
     rForward 10
  elseif LastMove = "Backward"
     rForward -10
  endif
return

DoLess:
  if LastMove = "Right"
    rTurn -10
  elseif LastMove = "Left"
    rTurn 10
  elseif LastMove = "Forward"
    rForward -10
  elseif LastMove = "Backward"
    rForward 10
  endif
return

DoAgain:
  if LastMove = "Right"
    gosub TurnRight
  elseif LastMove = "Left"
    gosub TurnLeft
  elseif LastMove = "Forward"
    gosub MoveForward
  elseif LastMove = "Backward"
    gosub MoveBackward
  elseif LastMove = "Wave"
    gosub DoWave
  elseif LastMove = "Who"
    gosub Greeting
  elseif LastMove = "Scan"
    gosub DoScan
  endif
return

IdentifyObject:
  // Color1 and Color2 have to be set up for objects you use
  call Say("Hold it still so I can see it better", normal)
  BMPfindClr "Temp",Color1,Found,SecCnt,.2,.05,9,CntInfo
  if Found
    call Say("It is a green object", happy)
  else
    BMPfindClr "Temp",Color2,Found,SecCnt,.2,.05,9,CntInfo
    if Found 
      call Say("It is a pink object", happy)
    else
      call Say("I do not see any object I know", sad)
    endif
  endif 
return

LearnColors: // learn two colors
  flip off
  call Say("Hold up two objects for me to learn", normal)
  delay 1000
  call GetImage("Cam2 10",BMP)
  // display image
  FitBmp "Temp"
  call Say("click object one", noface)
  repeat
    ReadMouse x,y,b
  until b
  // record objects color in col
  ReadPixel x,y,Color1
  delay 1000                   
  call Say("Touch or click object two", noface)
  repeat
    ReadMouse x,y,b
  until b
  // record objects color in col
  ReadPixel x,y,Color2
  delay 1000
  flip on
  ClearScr 
  gosub DrawFace
return

WatchObject:
  //ClearScr 
  //gosub DrawFace
  BMPfindClr "Temp",Color1,Found,SecCnt,.2,.05,9,CntInfo
  if Found
    col = Color1
  else
    BMPfindClr "Temp",Color2,Found,SecCnt,.2,.05,9,CntInfo
    if Found 
      col = Color2
    else
      call Say("I do not see any object I know", normal)
      Watch = false
    endif
  endif
  call Say("Move the object slowly    keep it in my view",normal)
  call Say("Just say FINISHED when you are ready to move on", normal)
  while True
    call GetImage("Cam2 10",BMP)
    // display image
    Found=-1
    //FitBmp "Temp"
    BMPfindClr "Temp",col,Found,SecCnt,.2,.05,9,CntInfo
    if Found>-1
      // determine grid coordinates of found block
      x=Found#9
      y=Found/9
      horz = 92-x*23
      vert = -35+y*9
      gosub Eyes
      gosub CheckForVoiceCommand   
      if InString(VoiceIn, "FINISH")
        horz = 0
        vert = 0
        gosub Eyes
        call Say("Okay what is next",happy)
        break
      elseif InString(VoiceIn, "IDENTIFY") or InString(VoiceIn, "WHICH")
        gosub IdentifyObject
      endif     
    endif
  wend
return

sub GetImage(Command,type)  
  FileDelete("Temp.jpg")
  // tell the Utility to take the picture
  SetCBtext(Command) 
  FileRename ("RBsTurn.txt","SensorsTurn.txt")  
  If type="BMP" then FileDelete("Temp.bmp")
  // wait for handshake
  while !FileExists("Temp.jpg")
  wend
  delay 100
  if type="BMP" then ToBmp "Temp.jpg"
return
  
DemoFace:
  call Say("okay",normal) \delay 100
  call Say("I can do that for you",happy)   
  call Say("This demo shows how to make the robot say what you want",normal) 
  for horz=0 to -100
    gosub DrawFace
  next
  call Say("I can be angry",angry) \delay 2000
  horz=0
  call Say("And I can be Happy",happy) \delay 2000
//  for horz=-100 to 0
//    gosub DrawFace
//  next
  call Say("Or sad", sad)\delay 2000 
  call Say("Even surprised", normal)
  call Say("",surprise)\delay 2000
  call Say("Pretty good huh", happy)\delay 2000
  horz=100 
//  for horz=0 to 100
//    gosub DrawFace
//  next
  delay 1000
  horz=0
//  for horz=100 to 0
//    gosub DrawFace
//  next    
return

sub InitSensors(a,b,c,d)    
  //NOTE: this utility was discussed in the Servo Magazine series Dec 2013-Mar 2014               
  // The Utility MUST reside in the same directory as
  // the application unless you set up paths 
  print "Initializing..."
  SetCBtext("stop") // stop utility if running
  filerename ("RBsTurn.txt","SensorsTurn.txt")
  delay 100
  Spawn ("RBsensorUtility.exe","",P_NOWAIT) 
  // provide time for Utility to spawn
  delay 1000 
  ClearScr   
  //  The above code can be eliminated if you always
  //  start the Utility manually. We have code in
  //  the utility that SHOULD prevent a second copy
  //  from running - but for some unknown reason it
  //  is not 100% reliable.  The above code seems to
  //  always work on our machine.
  dim Sensors[28] //max available from utility
  dim Offsets[4]                 
  for i=0 to 27
    Sensors[i]=""
  next
  // allow setting certain angles to zero
  Offsets[0]=a
  Offsets[1]=b
  Offsets[2]=c
  Offsets[3]=d 
  // Note: This line was added to the initialization
  // It fixes timing on FIRST use  
return


sub Say(s, style)
  // alter face parameters for each style
  // horz controls left and right position of eyes: -100[screen left] to 100
  // vert controls up/down position of eyes(-30 up to 30 down)
  // size controls the eye's height (squint, etc) (-20 to +20)
  // brows (0,1,2) indicates normal, down and up
  // mouth controls mouth movement type (0-normal, 1-smile, 2-frown
  //   3-constant, 4-vowel (all but O), 5-O sound 
  // These emotions are just a first attempt - play with various ideas and 
  // improve or add to them to meed your needs
  // NOTE: the value of SpeedDelay must be set ONCE to handle the timing for
  //   your machine.  Once set, the graphics and voice should be synchronized.
  // Note: Use style of 6 if you want to set ALL of your own parameters on the fly,
  //       or create special styles of your own
  if style = _normal
   // _horz = 0        // allows user to control the eye position
   // _vert = 0        // uncomment if you wish
    _size = 0
    _brows = 0
    _mouth = 0 
  elseif style = _angry
   // _horz = 0
   // _vert = 0
    _size = -5
    _brows = 1
    _mouth = 0 
  elseif style = _sad
    _horz = 0
    _vert = +25
    _size = 0
    _brows = 1
    _mouth = 2     
  elseif style = _happy
   // _horz = 0
   // _vert = 0
    _size = 5
    _brows = 0
    _mouth = 1
  elseif style = _surprise
    _horz = 0
    _vert = 0
    _size = 20
    _brows = 2
    _mouth = 5
  endif 
  temps=s
  if style!=_noface then gosub Eyes
  s=temps
  setcbtext("Say,"+s) // tell the Interface program what to read
   // now trigger  utility  to perform 
   filerename ("RBsTurn.txt","SensorsTurn.txt")
   // produce animation if requested
   if style!=_noface  // animate if pause>0 otherwise, just voice
     answer=0
     LineWidth 20
     if s="" 
       s="*"
     else
       s=s+" *"
     endif
     s=Lower(s)  
     mfromstring words,s," "
     for i=0 to _MaxWords-1
       State=""
       if words[i]="*" then break
       // animate next word
       for j=1 to Length(words[i])
         L=SubString(words[i],j,1)
         call IsVowel(L,answer)
         if (answer and (State="C"))  or ((!answer) and (State="V")) or (State="")
           if answer
             if L="o"
               _mouth=5\gosub DrawFace
             elseif !((L="e") and (Length(words[i])=j))
               _mouth=4\gosub DrawFace
             endif
             State="V"
           else
             _mouth=3\gosub DrawFace
             State="C"
           endif
         endif
       next
     next
     mouth=0\gosub DrawFace
     // reset mouth    
     if style = _normal
       _mouth = 0\gosub DrawFace
     elseif style = _happy
       _mouth = 1\gosub DrawFace
     elseif style = _sad
       _mouth = 2\gosub DrawFace
     elseif style = _surprise
       _mouth = 5\gosub DrawFace   
     elseif style = _angry
       _mouth = 0\gosub DrawFace   
     endif 
     flip
   endif 
   // continue waiting to ensure utility has finished speaking
   while !fileexists("RBsTurn.txt") 
   wend 
return


InitAnimateSay:
  SpeechDelay=39 // adjust to time voice to animation
  MaxWords=20
  Dim words[MaxWords]
  horz = 0
  OldHorz = 0
  vert = 0
  OldVert = 0
  size = 0
  brows = 0
  mouth = 0
  normal = 0
  angry = 1
  sad = 2
  happy = 3
  surprise = 4
  noface = 5
  flip on
  gosub DrawFace
  Call Say("",normal) // Corrects animation timing on first use
  
return

DrawFace:
  //controlled by these ROOT variables (horz,vert,size,brows,mouth)  
  gosub Eyes
  LineWidth 1
  // draw nose
  rectangle 340,365,455,400,white,white
  if _mouth = 5
    arc 349,360,453,399,2.9,3.65,1,black
  else
    arc 350,360,450,400,2.9,3.65,3,black
  endif
  line 360,363,390,200,3,black
  line 437,362,410,200,3,black
  //cheeks
  rectangle 90,340,340,250,white,white
  rectangle 730,340,458,250,white,white
  if _mouth = 3
    arc 100,330,350,180,4.5,1.5,2,black
    arc 700,330,450,180,3.4,1.5,2,black
  else
    arc 100,330,350,200,4.5,1.5,5,darkgray
    arc 700,330,450,200,3.4,1.5,5,darkgray
  endif

  flip
  // draw proper mouth
  if _mouth = 0
    gosub Normal
  elseif _mouth = 1
    gosub Smile
  elseif _mouth = 2
    gosub Frown
  elseif _mouth = 3
    gosub Constant
  elseif _mouth = 4
    gosub Vsound
  elseif _mouth = 5 
    gosub Osound
  endif
  flip
return

Eyes:
  // controlled by ROOT variables (horz,vert,size)
  Thorz=_OldHorz
  Tvert=_OldVert
  repeat
    // clear eye area
    rectangle 10,50,350,200,white,white
    rectangle 450,50,790,200,white,white 
    if Thorz<_horz then Thorz++
    if Thorz>_horz then Thorz--
    if Tvert<_vert then Tvert++
    if Tvert>_vert then Tvert--
    s=_size
    vt=0\vb=0
    if _vert>0 then vb=-_vert/5\vt=_vert/5
    if _vert<0 then vt=-_vert/5\vb=_vert/5
    LineWidth 30
    SetColor Black
    circle 50,95-s,350,225+s
    circle 450,95-s,750,225+s 
    LineWidth 5
    er=50
    circle Thorz+200-er,Tvert+160-er+vt,Thorz+200+er,Tvert+160+er+vb,blue,lightblue
    circle Thorz+600-er,Tvert+160-er+vt,Thorz+600+er,Tvert+160+er+vb,blue,lightblue 
    er=25
    circle Thorz+200-er,Tvert+160-er+vt,Thorz+200+er,Tvert+160+er+vb,black,black   
    circle Thorz+600-er,Tvert+160-er+vt,Thorz+600+er,Tvert+160+er+vb,black,black     
    LineWidth 35
    arc 50,95-s,350,225+s
    arc 450,95-s,750,225+s
    LineWidth 80
    SetColor white
    Arc 10,55-s,390,265+s   
    Arc 410,55-s,790,265+s
    line 60,55,200,40,20
    lineto 330,45,20
    line 740,55,600,40,20
    lineto 470,45,20 
    setcolor Black
    if _brows = 0   // normal
      line 60,85,200,65,20
      lineto 330,75,20
      line 740,85,600,65,20
      lineto 470,75,20
    elseif _brows = 1 // anger
      line 60,80,330,90,20
      line 470,90,740,80,20 
    elseif _brows = 2 // surprise
      line 60,55,200,40,20
      lineto 330,45,20
      line 740,55,600,40,20
      lineto 470,45,20
    endif          
    flip
  until (Thorz=_horz) and (Tvert=_vert)
  _OldHorz = Thorz
  _OldVert = Tvert
return


sub IsVowel(c,&answer)
  if c="a" or c="e" or c="i" or c="o" or c="u" or c="y"
    answer= true
  else
    answer= false
  endif
return

Smile:
  // 1
  linewidth 20
  rectangle 180,475,610,550,White,White
  line 220,475,280,500
  lineto 520,500
  lineto 580,475
  flip
return

Normal:
  // 0
  linewidth 20
  rectangle 180,470,610,550,White,White
  line 200,500,600,500
  flip
return

Frown:
  // 2
  linewidth 20
  rectangle 180,470,610,550,White,White
  line 200,520,240,500
  lineto 560,500
  lineto 600,520
  flip
return

Constant:
  // 3
  linewidth 10
  rectangle 180,470,610,550,White,White
  circle 200,500,600,510,black,red
  flip
  delay _SpeechDelay
return

Vsound:
  // 4
  linewidth 10
  rectangle 180,470,610,550,White,White
  //circle 300,395,500,430,black,red
  arc 220,490,580,505,3.1633,3.09
  arc 220,490,580,530,3.1,3.24
  floodfill2 500,510,red
  flip
  delay 2*_SpeechDelay
return

Osound:
  // 5
//_SpeechDelay=2000
  linewidth 10
  rectangle 180,470,610,550,White,White
  circle 220,500,580,510,black,red
  flip
  delay _SpeechDelay/2
  rectangle 180,470,610,550,White,White
  circle 290,505,510,530,black,red
  flip
  delay _SpeechDelay*2
  //rectangle 180,480,610,550,White,White
  //circle 220,500,580,510,black,red
  //flip
  delay _SpeechDelay/2
return


